
//       
// TradeContext.mqh  http://articles.mql4.com/ru/94
#include <TradeContext.mqh>  
extern int    StopLoss    =   60;  //    
extern int    TakeProfit  =  100;  //    
//   
extern double MACDOpenLevel = 3;
extern double MACDCloseLevel = 2;
extern double MATrendPeriod = 26; 

extern double Lots        = 0.01;  //                                                               
extern double Risk        = 0.01;  //    ,  0-    Lots       
extern int    balans      =  300;  //   , 300  MaximumRisk = 0.01, 3000 - 0.1   
extern int    Pleho       =  100;  //    

int slippage = 3; // 
int deals = 0; //   
int TimeForSleep = 10; //     
int time_for_action = 1; //  
int count = 5; //   / 
bool Trade = true; //   
bool NoOpen = false; //      

//        ----------------------------+   

bool ServerWork(){     
        if(DayOfWeek() == 0 || DayOfWeek() == 6)
        return(false); return(true);
}//ServerWork()

//  magik ----------------------------------------------------------+

int GenericMagik(){
        return(deals);
}//GenericMagik()

//   ----------------------------------------------------------+  

bool CloseOrder(int magik){
        int ticket,i;
        double Price_close;
        int err;
        int N;
        //      count ,     
        // ,       
while(N < count){          
for(i = OrdersTotal() - 1; i >= 0; i--){
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        if(OrderSymbol() == Symbol()) 
if(OrderMagicNumber() == magik){
        if(OrderType() == OP_BUY)        
        Price_close = NormalizeDouble(Bid, Digits);
        if(OrderType() == OP_SELL)        
        Price_close = NormalizeDouble(Ask, Digits);
if(OrderClose(OrderTicket(), OrderLots(),Price_close,slippage)){ 
        //      
        deals--;
        //    -   
        // 
        NoOpen = false;                           
        return(true);
}//OrderClose
        //    ,    
        N++;
        //   
        err = ErrorBlock();
        //   
if(err > 1){
        Print("    ", OrderTicket());
        return(false);
}//err
}//OrderMagicNumber                                          
}//for
        //  5      
        Sleep(5000);
        RefreshRates();
}//while
        //     ,      count  
        Print("    ", OrderTicket());
return(false);
}//CloseOrder

//  ---------------------------------------------------------------------+

double GetLots(){
        double minlot = MarketInfo(Symbol(), MODE_MINLOT);
        double maxlot = MarketInfo(Symbol(), MODE_MAXLOT);
if(Risk!=0){
        double lot = NormalizeDouble((AccountFreeMargin()*AccountLeverage() * Risk)/( balans * Pleho), 2);
        //             
        //       , -     .
        if(lot < minlot) lot = minlot;
        if(lot > maxlot) lot = maxlot;
}//Risk!
        else lot=Lots; 
        return(lot);
}//GetLots()

//   act 1-, 2- ---------------------------------------------+

int Deal(int act){
        int N = 0;
        int ticket;
        int err;
        double Price_open;
        double Lots1;
        int cmd1,cmd2;
        int magik;
        magik = GenericMagik();
        Lots1 = GetLots();

//-------  ---------------------------------------
if(act == 1){
        Price_open = NormalizeDouble(Ask, Digits);
        cmd1 = OP_BUY;
}//act
        //     
        AccountFreeMarginCheck(Symbol(), cmd1,Lots1);    
        err = GetLastError();
if(err>0){
        Print("    ");
        NoOpen = true;
        return(0);
}//err                   

//-------  --------------------------------------
if(act == 2){
        Price_open = NormalizeDouble(Bid, Digits);
        cmd2 = OP_SELL;
}//act
        //     
        AccountFreeMarginCheck(Symbol(), cmd2,Lots1);
        err = GetLastError();
if(err>0){
        Print("    ");
        NoOpen = true;
        return(0);
}//err

//-------------------------------------------------------------------------------------               
//  
//---------------------- Buy ----------------------------------------------------------                  

        ticket = OrderSend(Symbol(), cmd1, Lots1, Price_open, slippage,Bid-StopLoss*Point,Bid+TakeProfit*Point, 0, magik);
if(ticket > 0){
        deals++;
        return(ticket);
}//ticket
        //   ,   5          
else{
while(N < count){
        N++;
        err = ErrorBlock();
if(err == 1){
        Sleep(5000);
        RefreshRates();
        if(act == 1)
        Price_open = NormalizeDouble(Ask, Digits);
        ticket = OrderSend(Symbol(), cmd1, Lots1, Price_open, slippage,Bid-StopLoss*Point,Bid+TakeProfit*Point, 0, magik);
if(ticket > 0){
        deals++;
        return(ticket);
}//ticket
}//err
        //     
        if(err > 1)            
        return(0);               
}//else                                                       
}//while   

//-------------------------------------------------------------------------------------
//  
//---------------------- Sell ---------------------------------------------------------        

        ticket = OrderSend(Symbol(), cmd2, Lots1, Price_open, slippage, Ask+StopLoss*Point,Ask-TakeProfit*Point, 0, magik);
if(ticket > 0){
        deals++;
        return(ticket);
}//ticket
        //   ,   5          
else{
while(N < count){
        N++;
        err = ErrorBlock();
if(err == 1){
        Sleep(5000);
        RefreshRates();         
        if(act == 2)
        Price_open = NormalizeDouble(Bid, Digits);              
        ticket = OrderSend(Symbol(), cmd2, Lots1, Price_open, slippage, Ask+StopLoss*Point,Ask-TakeProfit*Point, 0, magik);
if(ticket > 0){
        deals++;
        return(ticket);
}//ticket
}//err
        //     
        if(err > 1)            
        return(0);               
}//else                                                      
}//while    
        return(0);
}//Deal

//-------------------------------------------------------------------------------------
//                                                         
// 0- , 1-   , 2- ,               
// 3-                                                         
//-------------------------------------------------------------------------------------

int ErrorBlock()
   {
   int err = GetLastError();
        switch(err)
        {
   case 0: return(0);
   case 2:
        {
        Print(" .  / ");
        Trade = false;
        return(3);  
        }
   case 3:
        {
        Print("   ");
        Trade = false;
        return(3);   
        }
   case 4:
        {
        Print("  .  2 ");
        Sleep(120000);
        return(2);   
        }
   case 6:
        { 
        bool connect = false;
        int iteration = 0;
        Print("Disconnect");
        while((!connect) || (iteration > 60))
        {
        Sleep(10000);
        Print("  , ", iteration*10, "");
        connect = IsConnected();
   if(connect)
        {
        Print(" ");
        return(2);
        }
        iteration++;
        }
        Trade = false; 
        Print("  ");
        return(3);
        }
   case 8:
        {
        Print(" ");
        Trade = false; 
        return(3);
        }
   case 64:
        {
        Print(" !");
        Trade = false; 
        return(3);            
        }
   case 65:
        {
        Print("  ???");
        Trade = false; 
        return(3);            
        }
   case 128:
        {
        Print("   ");
        return(2);
        }
   case 129:
        {
        Print(" ");
        return(1);            
        }
   case 130:
        {
        Print(" ");
        return(1);
        }
   case 131:
        {
        Print("   ");
        Trade = false;            
        return(3);
        }
   case 132:
        {
        Print(" ");
        NoOpen = true;  
        return(2);
        }
   case 134:
        {
        Print("     ");
        Trade = false;             
        return(2);
        }
   case 135:
        {
        Print(" ");
        return (1);
        }
   case 136:
        {
        Print(" !");
        return(2);
        }
   case 138:
        {
        Print(", !");
        return(1);
        }
   case 139:
        {
        Print("  .  ");
        return(2);
        }
   case 141:
        {
        Print("  ");
        Trade = false; 
        return(3);            
        }
   case 148:
        {
        Print("   ");
        NoOpen = true; 
        return(2);            
        }                                          
        }
return (0);
}

//-------------------------------------------------------------------------------------
//    /   Macd              
//-------------------------------------------------------------------------------------

int GetAction(int & action, double & Lots1, int & magik){
        double MacdCurrent, MacdPrevious, SignalCurrent;
        double SignalPrevious, MaCurrent, MaPrevious;
        int cnt, total;
//----   
        MacdCurrent = iMACD(NULL, 0, 12, 26,9, PRICE_CLOSE, MODE_MAIN, 0);
        MacdPrevious = iMACD(NULL, 0, 12, 26,9, PRICE_CLOSE, MODE_MAIN, 1);
        SignalCurrent = iMACD(NULL, 0, 12, 26,9, PRICE_CLOSE, MODE_SIGNAL, 0);
        SignalPrevious = iMACD(NULL, 0, 12, 26,9, PRICE_CLOSE, MODE_SIGNAL, 1);
        MaCurrent = iMA(NULL, 0, MATrendPeriod, 0, MODE_EMA, PRICE_CLOSE, 0);
        MaPrevious = iMA(NULL, 0, MATrendPeriod, 0, MODE_EMA, PRICE_CLOSE, 1);
//----
if(MacdCurrent < 0 && MacdCurrent > SignalCurrent && 
        MacdPrevious < SignalPrevious && MathAbs(MacdCurrent) > 
       (MACDOpenLevel*Point) && MaCurrent>MaPrevious){
       
        action = 1;
        Lots1 = GetLots();
        return(0);
}//if(Macd...

if(MacdCurrent > 0 && MacdCurrent < SignalCurrent && 
        MacdPrevious > SignalPrevious && 
        MacdCurrent>(MACDOpenLevel*Point) && MaCurrent < MaPrevious){
        
        action = 2;
        Lots1 = GetLots();
        return(0);               
}//if(Macd...
        total = OrdersTotal();
for(cnt = 0; cnt < total; cnt++){
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
if(OrderType() <= OP_SELL &&   // check for opened position 
        OrderSymbol() == Symbol())  // check for symbol
        {
if(OrderType() == OP_BUY)   // long position is opened
        {
        // should it be closed?
if(MacdCurrent > 0 && MacdCurrent < SignalCurrent && 
        MacdPrevious > SignalPrevious &&
        MacdCurrent > (MACDCloseLevel*Point)){
        
        action = 3;
        magik = OrderMagicNumber();
        return(0); // exit
}//if(Macd...
}//OP_BUY
else // go to short position
        {
        // should it be closed?
if(MacdCurrent < 0 && MacdCurrent > SignalCurrent &&
        MacdPrevious < SignalPrevious && 
        MathAbs(MacdCurrent) > (MACDCloseLevel*Point)){
                   
        action = 3;
        magik = OrderMagicNumber();
        return(0); 
}//if(Macd...
}//else 
}//OP_SELL
}//for
}//GetAction

//-------------------------------------------------------------------------------------
// expert initialization function                                         

int init(){ 
       if(!IsTradeAllowed()) {Print("  !"); return(0);}
}//init()

//-------------------------------------------------------------------------------------
// expert deinitialization function                                          

int deinit(){
//  
        for(int k = OrdersTotal() - 1; k >= 0 ; k--)
if(OrderSymbol() == Symbol()){
        if(OrderType() == OP_BUY)
        OrderClose(OrderTicket(), OrderLots(),NormalizeDouble(Bid,Digits), 10);               
        if(OrderType() == OP_SELL)
        OrderClose(OrderTicket(), OrderLots(),NormalizeDouble(Ask, Digits),10);                 
}//Symbol()
}//deinit() 

//-------------------------------------------------------------------------------------
// expert start function                                                    
//-------------------------------------------------------------------------------------

int start(){
       int action =0;
       double Lots1 = GetLots();
       int magik = 0;     
while(Trade){
       Sleep(time_for_action*1000);      
       RefreshRates();
       /* ,     , 
        
        magik   
       action 1-buy, 2-sell, 3-close
            Macd*/
       GetAction(action, Lots1, magik);
if(ServerWork()){
if(((action == 1) || (action == 2)) && (!NoOpen)){                                        
       if(TradeIsBusy() < 0) 
       return(-1); 
       Deal(action);
       Sleep(TimeForSleep*1000);                                
       TradeIsNotBusy();
}//if(((action == 1) || (action == 2)) && (!NoOpen)){
if(action == 3){
       if(TradeIsBusy() < 0) 
       return(-1); 
if(!CloseOrder(magik)){
       Print("   ");
       Sleep(TimeForSleep*1000);   
       TradeIsNotBusy();
}//if(!CloseOrder(magik)){ 
}//if(action == 3){
}//if(ServerWork()){
else{
       Print("");
       if(TradeIsBusy() < 0) 
       return(-1); 
       Sleep(1000*3600*48);
       TradeIsNotBusy();
}//else
       action = 0;
       Lots1 = 0;
       magik = 0;
}//while(Trade){
       Print("       ");  
       return(0);
}//start()
//+------------------------------------------------------------------+